%This function groups chords using fixed gap size. Gap size should be chosen
%according to the tempo of the performance
%T is the times extracted from the music vector for each event
%P is the pitches extracted from the music vector for each event
%max_notes is the maximum number of notes in a chord
%This function returns the pitches (in GP), the times (in GT),
%and the indices (in GI) in chords for the entire piece

function [GP, GT, GI] = group(T, P, max_notes, gap)

n = length(T);
GP = zeros(n, max_notes); GP(1,1) = P(1);
GT = zeros(n, max_notes); GT(1,1) = T(1);
GI = zeros(n, max_notes); GI(1,1) = 1;


j = 1; k = 1;
for i = 2:n
   if T(i) - T(i-1) > gap
      j = j + 1;
      k = 1;
   else
      k = k + 1;
  end
  if k > max_notes
	  error(sprintf('There are more than max_notes near time %f', T(i)));
  end

   GP(j, k) = P(i);
   GT(j, k) = T(i);
   GI(j, k) = i;
      
end



GP = GP(1:j,:);
GT = GT(1:j,:);
GI = GI(1:j,:);


